/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/




#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


//#define DEBUG_ON		// Pc debug
#define	ON_BOARD		// Arduino board

#define FLASH_LED		// Levare se non si vuole il flashing dei led
#define ARDUINO_IDE	//Se si compila con Arduino IDE. Per AVR4 Studio eliminare

#ifdef DEBUG_ON
#include <math.h>
#include <conio.h>
#include <time.h>
#include <stdarg.h>
#include <math.h>
#endif


#ifdef ON_BOARD
#include <avr/io.h>
#include <avr/interrupt.h>

#ifdef ARDUINO_IDE
#include "WProgram.h"
#include "pins_arduino.h"
#endif

#define strnicmp strncasecmp

#define CPU_XTAL        (16000000UL)

#define TIM5_STEP		(int)(TIM5_LOOP / 1e-6)
#define TIM5_MULT		4

#define TIM5_DIV		64		// 4 uS step clock
#define TIM5_LOOP		20e-3	// sync time 20 mS
#define	TIM5_RATE		(unsigned int)((float)TIM5_LOOP / (1.0 / ((float)CPU_XTAL/TIM5_DIV)))

#endif

// Dont't move from here
#include "LAB_Ext.h"
#include "LAB_Var.h"



#define TAB				9
#define SPACE			0x20
#define CR				0xd
#define BACKSPACE		8
#define ESC_CHAR		0x1b
#define CTRL_B			('B'-0x40)
#define CTRL_N			('N'-0x40)
#define CTRL_R			('R'-0x40)


#define MAX_LINE		255
#define MAX_MEM			4096
#define MAX_LIN_LEN		64
#define MAX_STACK		8
#define MAX_VAR			(('Z'-'A')+1)
#define MAX_IDX			256
#define MAX_RECURSE		32
#define MAX_FLD_LEN		16
#define MAX_E2PROM		1000
#define SER_BUF_SIZE    64		// Must be power of 2
#define SER_BUF_MASK    (SER_BUF_SIZE-1)
#define AUTO_RUN		'Y'
#define NO_AUTO_RUN		'N'



#define DECIMAL			1
#define HEXADECIMAL		2
#define BINARY			3


#define HEX_SYM			'$'
#define BIN_SYM			'#'

// UART settings
#define MODE_1			0
#define MODE_2			1
#define STOP_1			1
#define STOP_2			2

#define PARITY_ODD		1
#define PARITY_EVEN		2
#define NO_PARITY		3


