/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/





#include "LAB_Def.h"







int Get_Ordinal (int line)
{
int i,idx_pnt,cnt_line;

	cnt_line=0;
	Setup_FLUT();

	for (i=1; i<MAX_LINE; i++)
	{
	idx_pnt = Get_Line_Pnt(i);
	if ( idx_pnt == -1 ) break; // fine tavola
	if ( idx_pnt == -2 ) continue; // oltre 
	cnt_line++;
	if ( i == line ) break; // fine
	}

	return cnt_line;
}





char *Fast_Get_Next (int line)
{
	if ( line < 1 || line > MAX_LINE ) return (char*)(-1);
	return Fast_LUT[line-1];
}




int Setup_FLUT (void)
{
int i,idx_pnt,maxline;

	maxline=0;
	for (i=0; i<MAX_LINE; i++) Fast_LUT[i] = (char*)(0);

	for (i=1; i<MAX_LINE; i++)
	{
	idx_pnt = Get_Line_Pnt(i);
	if ( idx_pnt == -2 ) continue; 
	if ( idx_pnt == -1 ) break;
	Fast_LUT[i-1] = &Program[idx_pnt];
	maxline++;
	}

	return maxline;
}




char *Skip_Blank (char *line)
{
 while ( (*line == 0x20) || (*line == 0x9) ) line++;
 return(line);
}



int Get_Line_Pnt (int line)
{
int mp;

	mp = 0;
	while ( mp<MAX_MEM )
	{
	if ( atoi(&Program[mp]) == line ) return mp;
	if ( atoi(&Program[mp]) > line ) return -2;
	if ( !Program[mp] ) return -1;
	while (Program[mp]) mp++;
	mp++;
	}

	return -1;
}




int Get_Next (int num_l)
{
int bp;

	bp=0;
	while ( bp < Mem_size )
	{
	if (( atoi(&Program[bp]) >= num_l )|| !Program[bp] || (Program[bp] == 0xff)) return bp;
	while ( Program[bp] ) bp++;
	bp++;
	}

	return bp;
}


char *Skip_Line_Num (char *line)
{

	line = Skip_Blank(line);
	
	while (( *line >= '0' ) && ( *line <= '9' ) && *line ) line++;

	return (Skip_Blank(line));
}


// Torna 1 se linea finita
int Check_Term (char *l)
{
	l = Skip_Blank(l);
	if ( !(*l) ) return 1; else return 0;
}



void Line_To_Upper (char *line)
{
int ss,mp;

	mp=0;
	for (ss=0; ss<(int)(strlen(line)); ss++)
	{
	if ( !mp ) line[ss] = toupper(line[ss]);
	if ( line[ss] == '"' ) mp ^= 0x1;
	}

}


int Insert_Line (char *line)
{
int ss,mp,next_l,ccnt;

	if ( atoi(line) < 1 || atoi(line) > MAX_LINE ) 
		{ A_printf("\nWrong line number\n"); return -1; }

	Line_To_Upper(line);
	
	mp = Get_Next(atoi(line));

	if ( atoi(&Program[mp]) == atoi(line) ) // cancella
	{
	next_l=mp; 
	ccnt=0;
	while ( Program[next_l] && next_l < Mem_size ) { next_l++; ccnt++; }
	next_l++;
	if ( next_l >= Mem_size ) Program[mp]=0;

	else
		{
		ss = (Mem_size-((unsigned int)(&Program[next_l])-(unsigned int)(&Program[0]) )) + 1;
		memmove(&Program[mp],&Program[next_l],ss );
		}
	Mem_size -= ccnt;
	}

	if ( Check_Term(Skip_Line_Num(line)) ) return 0; //era una cancellazione

	if (( Mem_size + strlen(line) ) >= MAX_MEM )
		{ A_printf("\nMemory full\n"); return -1; }

	ss = (Mem_size-((unsigned int)(&Program[mp])-(unsigned int)(&Program[0]) ));
	if ( ss ) memmove(&Program[mp+strlen(line)+1],&Program[mp],ss );
	strcpy(&Program[mp],line);
	Mem_size += strlen(line)+1;

	return 0;
}










