/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/





#include "LAB_Def.h"



char			Program[MAX_MEM];
char			Line[MAX_LIN_LEN];
int				Mem_size;
char			Trace_On;
char			Auto_Run;
char			*Fast_LUT[MAX_LINE];
char			*PMP;
int				Ctrl_break;
int				Vettore_index[MAX_IDX];
char			Recurse;
int				Vettore_variabili[MAX_VAR];
int				Stack_sub[MAX_STACK];
int				Stack_pnt;
unsigned char	Ser_Rx_Buffer[SER_BUF_SIZE];
unsigned char	Ser_Tx_Buffer[SER_BUF_SIZE];
unsigned char	Ser_Rx_Rd_pnt,Ser_Rx_Wr_pnt,Ser_Rx_Cnt;
unsigned char	Ser_Tx_Rd_pnt,Ser_Tx_Wr_pnt,Ser_Tx_Cnt;
unsigned char	Rx_Buf_Pnt;
unsigned long	Tim_5_Counter;


#ifdef DEBUG_ON
clock_t			Timer_Start,Timer_End;
#endif

#ifdef ON_BOARD
unsigned long	Timer_Start,Timer_End;
#endif












void New (void)
{
int mp;

	Timer_Start = A_clock();

	Trace_On=0;
	Ctrl_break=0;
	Auto_Run=NO_AUTO_RUN;

	Recurse=0;
	Stack_pnt=0;
	for(mp=0; mp<MAX_VAR; mp++) Vettore_variabili[mp]=0; 
	for(mp=0; mp<MAX_IDX; mp++) Vettore_index[mp]=0; 
	for(mp=0; mp<MAX_MEM; mp++) Program[mp]=0; 
	Mem_size=0;

}

#define LOAD_TEST
void Load_Test_program (void)
{
#ifdef LOAD_TEST

	sprintf(Line,"10 B=10");	Insert_Line(Line);
	sprintf(Line,"20 C=20");	Insert_Line(Line);
	sprintf(Line,"30 A=3*(190/(B+(C+2)))");	Insert_Line(Line);
	sprintf(Line,"40 PRINT A");	Insert_Line(Line);
	sprintf(Line,"50 B=B+5");	Insert_Line(Line);
	sprintf(Line,"60 REM");	Insert_Line(Line);
	sprintf(Line,"70 IF A > 5 THEN GOTO 30");	Insert_Line(Line);

#endif
}


int main (void)
{

	A_Board_Init();

	if ( Get_Auto_Run() )
	{
	// nothing
	}

	A_printf("\nLAB Ver. Alpha 0.1 [10/03/2011]\n");
	A_printf("(type HELP for help)\n\n");

	New();

	Load_Test_program();

	while (1)
	{
		if ( Get_Edit_Line(0,Line) )
		{
		if ( atoi(Line) )						Insert_Line(Line);	
		else if ( !strnicmp(Line,"LIST",4) )	List(Line+4);
		else if ( !strnicmp(Line,"EDIT",4) )	Get_Edit_Line(1,Line+4);

#ifdef DEBUG_ON
		else if ( !strnicmp(Line,"QUIT\0",5) )  exit(0);
#endif

		else if ( !strnicmp(Line,"SAVE\0",5) )	Save(); 
		else if ( !strnicmp(Line,"LOAD\0",5) )	Load(); 

		else if ( !strnicmp(Line,"NEW\0",4) )	New(); 
		else if ( !strnicmp(Line,"HELP",4) )	Help();
		else if ( !strnicmp(Line,"TRON\0",5) )	Trace_On=1;
		else if ( !strnicmp(Line,"TROFF\0",6) )	Trace_On=0;
		else if ( !strnicmp(Line,"RUN",3) )		{ Run_Instr(Line+3,0); A_printf("\n"); }
		else if ( !strnicmp(Line,"RENUM",5) )	Renum_program(Line+5);
		else if ( !strnicmp(Line,"RESUME\0",6))	Run_Instr(0,1);
		else if ( !strnicmp(Line,"MEM\0",4) )	A_printf("Free memory %d bytes %d line(s)\n",
												MAX_MEM-Mem_size,(Setup_FLUT()>0)?Setup_FLUT():0);
		else 
		{ 
		Line_To_Upper(Line); 
		if ( Scan_Line (Line,0) == 'N' ) A_printf ("Unknow command\n"); }
		}
	}

	return 0;

}


