/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/





#include "LAB_Def.h"





int Balance_line (void)
{
int i;
char *p,*s;
char *line;


		for (i=1; i<MAX_LINE; i++)
		{
		Setup_FLUT();
		line = Fast_Get_Next(i);
		if ( !line ) continue;
		if ( line == (char*)(-1) ) break;
		strcpy(Line,line);
		line = Line;
		while (( *line >= '0' ) && ( *line <= '9' ) && *line ) line++;
		line++;
		if ( *line == SPACE )
			for (p=line; p<(char*)(line+strlen(Line)); p++) *p = *(p+1);

		s=0;
		if ( strstr(line ,"GOTO ") )  s=(char*)(strstr(line ,"GOTO " )+5);
		if ( strstr(line ,"GOSUB ") ) s=(char*)(strstr(line ,"GOSUB ")+6);
		if ( strstr(line ,"ENDL ") )  s=(char*)(strstr(line ,"ENDL " )+5);

		if ( s ) 
			for (s=s; s<(char*)(line+strlen(Line)+1); s++) *s = *(s+1);
		Insert_Line(Line);
		}

		return 0;
}




void Copy_number(char *line, int num, int dir)
{
int p;

	for (p=0; p<3; p++) *(line+p)=SPACE;

	if ( num < 10 )   
	{ 
		if ( !dir ) *line=(char)(0x30+num); 
		else *(line+2)=(char)(0x30+num);
	}
	
	else if ( num < 100 )  
	{ 
		if ( dir ) line++;
		*line=(char)(0x30+(num/10)); 
		line++; 
		*line=(char)(0x30+(num%10)); 
	}
	else
	{ 
		*line=(char)(0x30+(num/100)); 
		line++; 
		*line=(char)(0x30+((num%100)/10)); 
		line++; 
		*line=(char)(0x30+((num%100)%10)); 
	}


}





int Expand_line (void)
{
int i;
char *p,*s;
char *line;

		for (i=1; i<MAX_LINE; i++)
		{
		Setup_FLUT();
		line = Fast_Get_Next(i);
		if ( !line ) continue;
		if ( line == (char*)(-1) ) break;
		if ( strlen(line) > MAX_LIN_LEN-4 ) return i;
		strcpy(Line,line);
		line = Skip_Line_Num(Line);

		for (p=(char*)(line+strlen(Line)+1); p>line; p--) *p = *(p-1);
		*line=SPACE;

		s=0;
		if ( strstr(line ,"GOTO ") )  s=strstr(line ,"GOTO " )+5;
		if ( strstr(line ,"GOSUB ") ) s=strstr(line ,"GOSUB ")+6;
		if ( strstr(line ,"ENDL ") )  s=strstr(line ,"ENDL " )+5;

		if ( s ) 
			{
			for (p=(char*)(s+strlen(Line)+1); p>s; p--) *p = *(p-1);
			*s=SPACE;
			}

		Insert_Line(Line);
		}

		return 0;
}





int Renum_program (char *num)
{
int step,maxline;
int i,ld,savn,ord,iline;
char *rlp,*flag_pnt;

	step = atoi(num);
	if ( step < 1 ) { printf("Illegal step\n"); return 0; }

	maxline = Setup_FLUT();

	if ( !maxline ) return 0;

	if ( ( maxline * step ) > MAX_LINE )
		{ printf("Last line number too big reduce step\n"); return -1; }

	if ( (Mem_size+(maxline*6)) >= MAX_MEM )
		{ printf("Not enough memory\n"); return -1; }

	i = Expand_line();
	if ( i )
		{ printf("Line too long at %d\n",i); return -1; }

	for (i=1; i<MAX_LINE; i++)
	{
	rlp = Fast_Get_Next(i);
	if ( !rlp ) continue;
	if ( rlp == (char*)(-1) ) break;

	savn = atoi(rlp);
	rlp = Skip_Line_Num(rlp);
	flag_pnt = rlp;
	if ( !strnicmp ( rlp ,"IF ",3) )
			{
			if ( !strstr( rlp ,"THEN " ) )
				   { printf("\nMissing THEN at %d\n",i); continue; }
			  rlp = strstr( rlp ,"THEN ")+5; // cerca numero
			}

	if ( !strnicmp ( rlp  ,"ENDL ",5) )
			{
			  ld = atoi (rlp+5);
			  if ( !ld || !(*rlp) )
					 { printf("\nENDL line missing at %d\n",i); continue; }
			  else
			  rlp = strstr( rlp ,"ENDL ")+5; // cerca numero
			}

	if ( !strnicmp ( rlp ,"GOSUB ",6) )
			{
			  ld = atoi (rlp+6);
			  if ( !ld || !(*rlp) )
					 { printf("\nGOSUB with wrong line at %d\n",i); continue; }
			  else
			  rlp = strstr( rlp ,"GOSUB ")+6; // cerca numero
			}

	if ( !strnicmp ( rlp ,"GOTO ",5) )
			{
			  ld = atoi (rlp+5);
			  if ( ( !ld ) || !(*rlp) )
			       { printf("\nGOTO with wrong line at %d\n",i); continue; }
			  else
			  rlp = strstr( rlp ,"GOTO ")+5; // cerca il goto
			}

	if ( flag_pnt != rlp ) // c' il numero da cambiare!
		{
		savn = atoi(rlp); // numero da cambiare
		flag_pnt = Fast_Get_Next(savn);
		if ( !flag_pnt || flag_pnt == (char*)(-1) )
			       { printf("\nIllegal line at %d\n",i); continue; }
		ord = Get_Ordinal(savn); // ordinale programma
		ord *= step; // nuovo numero
		Copy_number(rlp,ord,1);
		}
	}

	savn = step;
	for (iline=1; iline<MAX_LINE; iline++)
	{
	rlp = Fast_Get_Next(iline);
	if ( !rlp ) continue;
	if ( rlp == (char*)(-1) ) break;
	Copy_number(rlp,savn,0);
	savn += step;
	}

	Balance_line();
	return 0;

}










