/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/



#include "LAB_Def.h"








int Run_Instr (char *command_line,int resume)
{
int save_pnt,err,bl,lv,rl,rets;
long par1,par2;
char *tl,op1,op2;

	lv = 0; // attenzione rivedere
	if ( resume )
	{
		if ( !Ctrl_break ) { A_printf("\nCan't continue\n"); return -1; }
			else save_pnt = Ctrl_break;
	}
	else
	{
	rl = -1;
	lv = -1;

	command_line = Skip_Blank(command_line);

	if ( *command_line )
		{
			save_pnt = atoi(command_line);
			if ( Get_Line_Pnt(save_pnt) < 0 ) { A_printf("\nLine missing\n"); return -1; }
		}
		else save_pnt = 1; // first line
	}


	Ctrl_break = 0;
	Setup_FLUT();

	while (1) // Main RUN
	{
	err = -1;
	PMP = Fast_Get_Next(save_pnt); // linea index
	
	if ( PMP == (char*)(0) ) { save_pnt++; continue; }
	
	if ( PMP == (char*)(-1) ) return 0;

	save_pnt = atoi(PMP);

	if ( A_sense_char() == ESC_CHAR ) 
		{
		A_getch();
		Ctrl_break = save_pnt;
		A_printf("\nBreak at line %d\n",save_pnt);
		return 0;
		}

	if ( Trace_On &&  *PMP ) A_printf("%s\n",PMP);

	PMP = Skip_Line_Num(PMP);

	if ( !strnicmp ( PMP,"IF ",3) )
		{
		tl = PMP+3;
		tl = Skip_Blank(tl);
		tl = Get_value( tl,&par1 );
		if ( par1 == -1L )
			{ A_printf("\nWrong IF at %d\n",save_pnt); return -1; }

		 tl = Skip_Blank(tl);
		
		 if ( ( *tl != '=' )&&( *tl != '<' )&&( *tl != '>' )&&( *tl != '!' ) )
			 { A_printf("\nWrong IF at %d\n",save_pnt); return -1; }

		op2 = 0;
		op1 = *tl;
		tl++;

		if ( *tl == '=' ) { op2 = *tl; tl++; }

		tl = Skip_Blank(tl);
		tl = Get_value( tl , &par2 );
		if ( par2 == -1L )
			{ A_printf("\nWronf IF at %d\n",save_pnt); return -1; }

		tl = Skip_Blank(tl);
		if ( strnicmp ( tl,"THEN ",5) != 0 )
			{ A_printf("\nWrong THEN at %d\n",save_pnt); return -1; }

		tl += 5;
		tl = Skip_Blank(tl);
		err = 0;

			if ( !op2 )
			{
			if ( op1 == '=' ) if ( par1 == par2 ) { PMP = tl; err = -1; } 
			if ( op1 == '>' ) if ( par1 > par2  ) { PMP = tl; err = -1; } 
			if ( op1 == '<' ) if ( par1 < par2  ) { PMP = tl; err = -1; } 
			}	
			else
			{
			if (( op1 == '!' )&&( op2 == '=' )) if ( par1 != par2  ) { PMP = tl; err = -1; } 
			if (( op1 == '>' )&&( op2 == '=' )) if ( par1 >= par2  ) { PMP = tl; err = -1; } 
			if (( op1 == '<' )&&( op2 == '=' )) if ( par1 <= par2  ) { PMP = tl; err = -1; } 
			}
			if ( !err ) while ( *PMP ) PMP++; 
		}

	if ( !strnicmp ( PMP,"STOP\0",5) )
			{ err = 0; A_printf("Stop!\n"); return 0; }


	if ( !strnicmp ( PMP,"GOTO ",5) )
			{
			  err = 0;
			  tl = PMP+5;
			  tl = Get_value(tl,&par1);
			  bl = (int)(par1);
			  if ( ( par1 == -1) ||
				   ( !Fast_Get_Next(bl) ) ||
				   ( Fast_Get_Next(bl) == (char*)(-1) ) )
				   { A_printf("\nWrong GOTO at %d\n",save_pnt); return -1; }
			  save_pnt = bl;
			continue;
			}

	if ( !strnicmp ( PMP,"LOOP ",5) )
			{
			  err = 0;
			  if ( lv != -1 )
				 { A_printf("\nNested LOOP at %d\n",save_pnt); return -1; }
			  lv = atoi (PMP+5);
			  if ( lv < 1 )
				 { A_printf("\nWrong LOOP line at %d\n",save_pnt); return -1; }
			}

	if ( !strnicmp ( PMP,"GOSUB ",6) )
			{
			  err = 0;
			  tl = PMP+6;
			  tl = Get_value(tl,&par1);
			  rl = (int)(par1);
			  if ( ( par1 == -1) ||
				   ( !Fast_Get_Next(rl) ) ||
				   ( Fast_Get_Next(rl) == (char*)(-1) ) )
				   { A_printf("\nWrong GOSUB line at %d\n",save_pnt); return -1; }
			  Stack_sub[Stack_pnt] = save_pnt+1;
			  Stack_pnt++;
			  if ( Stack_pnt > MAX_STACK )
				   { A_printf("\nGOSUB overflow at %d\n",save_pnt); return -1; }
			  save_pnt = rl;
			  continue;
			}

	if ( !strnicmp ( PMP,"RETURN",6) )
			{
			  err = 0;
			  if ( !Stack_pnt )
				   { A_printf("\nRETURN w/o GOSUB at %d\n",save_pnt); return -1; }
			  save_pnt = Stack_sub[Stack_pnt-1];
			  Stack_pnt--;
			  continue;
			}

	if ( !strnicmp(PMP,"ENDL ",5) )
			{
			  err = 0;
			  if ( lv  == -1 )
			       { A_printf("\nENDL w/o LOOP at %d\n",save_pnt); return -1; }
			  rl = atoi (PMP+5);
			  if ( ( !Fast_Get_Next(rl) ) ||
				   ( Fast_Get_Next(rl) == (char*)(-1) ) )
				   { A_printf("\nWrong ENDL line at %d\n",save_pnt); return -1; }
			  lv--;
			  if ( lv > 0 ) { save_pnt = rl; continue; } else lv = -1;
			}

	if ( !strnicmp ( PMP,"INKEY",5) )
			{
			if ( !Check_Term(PMP+5) ) { A_printf("\nExtra char on line %d\n",save_pnt); return -1; }
			else while ( A_sense_char() == -1 );
			}


	if ( !strnicmp ( PMP,"INPUT",5) )
			{
			err = Field_input(PMP+5);
			if ( err == -1 ) { A_printf("\nInput error at %d\n",save_pnt); return -1; }
			if ( err == -2 ) return 0;
			}

	if ( err )
	{
	rets = Scan_Line( PMP , save_pnt );

	if ( rets == 'B' ) 
		{
		A_getch();
		Ctrl_break = save_pnt;
		A_printf("\nBreak at line %d\n",save_pnt);
		return 0;
		}

	if ( rets == 'E' ) return -1;
		else if ( rets == 'F' ) err = 0;
	}

	if ( err ) { A_printf("\nError at %d\n",save_pnt); return -1; }
	save_pnt++;
	}

  return -1;
}




