/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/



#include "LAB_Def.h"





int Delay (int wait)
{

	do 
	{
	Delay_1mS();
	if ( A_sense_char() == ESC_CHAR ) return -1;
	}
	while (wait--); 

	return 0;
}




int Scan_Line (char *l,int save_line)
{
int wt;

	if ( Test_Variable(l) )
	{ 
		if ( Load_variable(l) ) return 'F'; 
		else { A_printf("Expression error %s\n",l); return 'E'; } 
	}

	if (( !strnicmp(l,"REM",3) )||( *l == ';' )) return 'F';

	if (( !strnicmp(l,"PRINT",5) )||( *l == '?' ))
			{
			if ( *l == '?' ) Print_Instr(l+1);
			else Print_Instr(l+5);
			return 'F';
			}

	if ( !strnicmp ( l,"TSTART\0",7) ) { Timer_Start = A_clock(); return 'F'; }

	if ( !strnicmp ( l,"TSTOP\0",6) ) { A_printf("%ld msec\n",A_clock()-Timer_Start); return 'F'; }

	if ( !strnicmp ( l , "WAIT " , 5) )
			{
			  wt = atoi (l+5);
			  if ( !wt )
				 { A_printf("\nWait error at %d\n",save_line); return -1; }
			  if ( Delay(wt) ) return 'B';
			  return 'F';
			}


	return 'N';
}








