/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/



#include "LAB_Def.h"






char *Get_value (char *line,long *value)
{

	*value=-1;

	line = Skip_Blank(line);
	if ( Test_if_num(line) ) line = Get_number(line,value);
	else if ( Test_Variable(line) ) line = Get_variable(line,value);

	return line;
}





char *Get_number (char *line,long *number)
{
int v,x;
char s;

	s = 0;

	line = Skip_Blank(line);

	switch ( Test_if_num(line) )
	{

	case(DECIMAL): /* Decimale */
	v = 0;
	if ( *line == '-' ) { line++; s = 1; }
	
	while (( *line >= '0' ) && ( *line <= '9' ))
		{ v = (v*10) + (*line - 0x30); line = line + 1; }

	if ( s ) *number=-v; else  *number=v;
	return line;

	case(BINARY): /* Binario */
	v = 0;
	line++;
	line = Skip_Blank(line);
	while (( *line == '0' ) || ( *line == '1' ))
		{ v = (v<<1) | (*line - 0x30); line = line +1; }
	*number = v;
	return line;

	case(HEXADECIMAL): /* Esadecimale */
	v = 0;
	line++;
	line = Skip_Blank(line);
	while ( (( *line >= '0' ) && ( *line <= '9' ))||(( *line >= 'A' ) && ( *line <= 'F' )) )
	{
	x = *line - 0x30; if ( x > 9 ) x -= 7;
	v = (v<<4) | x; line = line + 1;
	}
	*number = v;
	return line;
	}

	*number = -1L;
	return line;
}










int Test_Variable (char *l)
{
long retv;

	l = Skip_Blank(l);

	if ( (( *l < 'A' ) || ( *l > 'Z' ))&&( *l != '@')&&( *l != '.') ) return 0;

	if ( *l == '@')
	{
	l++;
	l = Skip_Blank(l);
	if ( *l != '[') return 0; else return -1;
	}

	if ( *l == '.')
	{
	//lasciare il punto
	l = Skip_Blank(l);
	Get_Register(l,&retv);
	if ( retv == -1L ) return 0; else return -1;
	}

	l++;
	if ( (*l < '0' ) || (*l > 'Z') || ((*l >'9')&&(*l<'A')) )
	return -1; else return 0;
}







int Test_if_num (char *l)
{
int c;

 l = Skip_Blank(l);

 if ( *l == BIN_SYM )
 {
   l++;
   l = Skip_Blank(l);
   if (( *l < '0' ) || ( *l > '1' )) return 0;
   l++;
   c = 0;
   while (( *l >= '0' ) && ( *l <= '1' )) { c++; l++; }
   if ( c > 15 ) return 0;
   return BINARY;
 }


 if ( *l == HEX_SYM )
 {
 l++;
 l = Skip_Blank(l);
 if ( ( *l < '0' ) || ( *l > 'F' ) ||(( *l > '9' ) && ( *l < 'A' )) ) return 0;
 c = 0;
 while ( (( *l >= '0' ) && ( *l <= '9' ))||(( *l >= 'A' ) && ( *l <= 'F' )) )
 { c++; l++; }

 if ( c > 4 ) return 0;

 return HEXADECIMAL;
 }


 if ((( *l < '0' ) || ( *l > '9' ))&&( *l != '-')) return 0;
 l++;
 c = 0;
 while ( ( *l >= '0' ) && ( *l <= '9' )) //||(( *l >= 'A' ) && ( *l <= 'F' )) )
 { c++; l++; }

 if ( c > 12 ) return 0;

 return DECIMAL;
}


